<?php

namespace App\Services\Api;

use App\Services\FileService;
use App\Services\Traits\Pdf\BasePdfTemplate;
use Illuminate\Support\Facades\Storage;

class ChemicalsMsdsService
{
    use BasePdfTemplate;

    public function getMsds($cas, $type = null, $comInfo = null)
    {
        $fileService = app(FileService::class);
        $msdPdf = $fileService->getFileListByModelData($comInfo['cus_type'].'_'.$cas.'_msds', $comInfo['cus_number']);
        if($msdPdf){
           return $fileService->getDownloadUrl(current($msdPdf)['uniqueid']);
        }

        $findResult = shell_exec('find '.env('MSDS_FILE_DIR').' -iname \''.$cas.'\' -print');
        if(is_null($findResult)){
            return null;
        }

        $msds_html = file_get_contents(env('MSDS_FILE_DIR').'/'.$cas.'/'.$cas.'_sds_'.$type.'.html');
        if($msds_html){
            if(!is_null($comInfo)){
                $platformParams = json_decode($comInfo['platform_params'], true);
                $msds_html = preg_replace('/<dt>企业名称：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业名称：<\/dt> <dd>'.$platformParams['company_name'].'<\/dd>', $msds_html);
                $msds_html = preg_replace('/<dt>企业地址：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业地址：<\/dt> <dd>'.$platformParams['company_address'].'<\/dd>', $msds_html);
                $msds_html = preg_replace('/<dt>传真：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>传真：<\/dt> <dd>'.$platformParams['company_fax'].'<\/dd>', $msds_html);
                $msds_html = preg_replace('/<dt>联系电话：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>联系电话：<\/dt> <dd>'.$platformParams['company_phone'].'<\/dd>', $msds_html);
            }
            $this->getPdfApp()->loadHTML($msds_html, 'utf-8');
            //echo $htmlTemp;
            $this->getPdfApp()->render();
            $pdf = $this->getPdfApp()->output();

            if($pdf){
                $fileName = $cas.'/'.$comInfo['cus_number'].'_'.$cas.'_'.$comInfo['cus_type'].'_msds.pdf';
                $realPath = $fileService->getFileFolderPath().'/'.$fileName;
                if($fileService->saveToFile($realPath, $pdf)){
                    $fileSave = [];
                    $fileSave['uniqueid'] = $fileService->getBase64Path($realPath);
                    $fileSave['type'] = 'file';
                    $fileSave['path'] = $realPath;
                    $fileSave['name'] = str_replace('.pdf','',$fileName);
                    $fileSave['extension'] = 'pdf';
                    $fileSave['mime_type'] = 'application/pdf';
                    $fileSave['byte_size'] = '';
                    $fileSave['model_name'] = $comInfo['cus_type'].'_'.$cas.'_msds';
                    $fileSave['model_data_id'] = $comInfo['cus_number'];
                    if($fileService->saveFileRecord($fileSave)){
                        return $fileService->getDownloadUrl($fileSave['uniqueid']);
                    }
                }
            }
        }

        return null;
    }
}
